#include "stdafx.h"
#include "_window.h"
#include "resource.h"
#include "_gfx.h"
#include "_shared.h"
#include "_render.h"
#include "_input.h"

HWND			hWnd;
WNDCLASS		wcWindow;
DWORD			end, start;

int				bExit = 0;

LRESULT CALLBACK _win_wndproc(
			HWND hwnd,      
			UINT uMsg,      
			WPARAM wParam,  
			LPARAM lParam   )
{
	switch ( uMsg )
	{
		case	WM_CLOSE:	
			PostQuitMessage(0); 
			bExit = 1;
			return 1;
		case	WM_PAINT:	
			return 1;
		case	WM_SIZE:
				_gfx_resize( LOWORD(lParam), HIWORD(lParam), 0 );
			break;
		case WM_ACTIVATE:
			if (LOWORD(wParam))
				_input_acquire();
			return 0; 
		case WM_KEYDOWN:
			if (27 == wParam)
			{
				PostQuitMessage(0); 
				bExit = 1;
				return 1;
			}

	}
	return DefWindowProc(hwnd, uMsg, wParam, lParam);
}




HWND		_win_init( 
			int nWidth, 
			int nHeight, 
			HINSTANCE hInstance, 
			bool bFullscreen )
{
	ZeroMemory(&wcWindow, sizeof(WNDCLASS));

	wcWindow.hInstance		= hInstance;
	wcWindow.style			= CS_VREDRAW|CS_HREDRAW|CS_OWNDC;
	wcWindow.lpfnWndProc	= _win_wndproc;
	wcWindow.lpszClassName  = WNDCLASSNAME;
	wcWindow.hbrBackground  = CreateSolidBrush(RGB(0,0,0));
	wcWindow.hIcon			= LoadIcon(hInstance, MAKEINTRESOURCE(IDI_MAINICON));

	if (!RegisterClass(&wcWindow))
		return 0;

	if (!bFullscreen)
	{
		hWnd =	CreateWindow(	WNDCLASSNAME,
							WNDTITLE,
							WS_OVERLAPPEDWINDOW,
							0,0, nWidth, nHeight,
							NULL, NULL,
							hInstance, NULL );
	}
	else
	{
		hWnd =	CreateWindow(	WNDCLASSNAME,
							WNDTITLE,
							WS_POPUP,
							0,0, nWidth, nHeight,
							NULL, NULL,
							hInstance, NULL );

		ShowCursor(false);
	}
	
	return hWnd;
}




int		_win_mainloop()
{
	MSG		msg;

	end = start = GetTickCount();

	while (!(bExit))
	{
		if ( PeekMessage(&msg, hWnd, 0, 0, PM_REMOVE ) )
		{
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}

		end = GetTickCount();

		_input_update();
		_world_update( (end-start) / 1000.0f );
		_r_render_scene();
	}

	return msg.message;
}